/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// ユーザ登録処理　入力画面表示ビジネスAction
// 
//
//	変更履歴
//	2004.01.08 新規作成 M.Seko 
//

package jp.co.ntt.lms.xms.people;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import jp.co.ntt.lms.xmo.Mail.MailConst;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsSystemException;
import jp.co.ntt.lms.xms.common.mail.InputFrameErrorBean;
import jp.co.ntt.lms.xms.common.mail.MailTemplateConstant;
import jp.co.ntt.lms.xms.common.util.CommonUtil;

/**
 * ユーザ登録処理　入力画面表示ビジネスAction。<br>
 * メニューからユーザ登録を選択した際に、
 * 画面表示を行うために使用する。
 * 
 *  @author M.Seko
 */
public class PeopleInsertInputFramesetDisplayBusinessAction extends XmsBusinessAction {

	/**
	 * @see jp.co.ntt.lms.xms.framework.XmsBusinessAction#initProcessRequest(XmsRequest)
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {
		//もしセッションキー管理クラスのインスタンスが既にセッション中に存在していれば、
		//セッション中の情報を削除する。

		// HTTPセッション取得用
		HttpServletRequest request = null;
		// HTTPセッション
		HttpSession session = null;
		//セッションキー保持クラスのセッションからの取得試行用
		SKeyKeep skeyKeep = null;

		request = xmsRequest.getRequest();
		session = request.getSession(false);
		if (session == null) {
			//sessionが無効である場合、処理が続行できないので例外を吐く
			throw new XmsSystemException("This session is invalid.");
		}

		skeyKeep = (SKeyKeep) session.getAttribute(PeopleConst.SKeyKeepSessionKey);

		if (skeyKeep != null) {
			//セッションキー保持クラスが既にセッションに存在している。
			//よって、セッションキー保持クラスが保持しているセッションキーに結びついているデータを削除
			CommonUtil.removeSessionData(xmsRequest, skeyKeep.getSkeyStringArray());
		}

		//元の画面への復帰に必要な情報をセッションに格納する。
		PeopleInsertComeBackInfoBean peopleInsertComebackInfoBean =
			new PeopleInsertComeBackInfoBean();
		peopleInsertComebackInfoBean.setReturnURL(request.getParameter("returnURL"));
		session.setAttribute(PeopleConst.ComebackInfoSessionKey, peopleInsertComebackInfoBean);

	}

	/**
	 * メールの使用可能・不可能に応じて処理を振り分ける。<br>
	 * また、formから入力されるユーザ情報の内容が格納されたセッション情報をクリアにする。<br>
	 * @see jp.co.ntt.lms.xms.framework.XmsBusinessAction#processRequest(XmsRequest, XmsResponse)
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse)
		throws XmsException {
		// HTTPセッション取得用
		HttpServletRequest request = null;
		// HTTPセッション
		HttpSession session = null;

		request = xmsRequest.getRequest();
		session = request.getSession(false);
		if (session == null) {
			//sessionが無効である場合、処理が続行できないので例外を吐く
			throw new XmsSystemException("This session is invalid.");
		}

		//ユーザがメニューからユーザ登録画面を表示した際に、念のため登録フォーム退避情報を削除する。
		//本来ならば、initProcessRequestメソッドで削除されるはずである。
		session.removeAttribute(PeopleConst.PeopleFormInfoSessionKey);

		//登録フォーム退避情報格納用Beanを生成する
		//ユーザ登録機能が呼び出されるときのGETパラメータで一緒に格納する必要のあるものがあるので
		PeopleFormInfoBean peopleFormInfoBean = new PeopleFormInfoBean();

		//親グループのIDを取得
		String parentID = null;
		parentID = request.getParameter("parentID");
		if ((parentID != null) && (parentID.equals("") == false)) {
			//親グループIDがあれば、Beanに値を登録
			peopleFormInfoBean.setParentID(parentID);
		} else {
			//親グループIDが無ければ、エラー画面へ遷移する
			InputFrameErrorBean inputFrameErrorBean = new InputFrameErrorBean();
			inputFrameErrorBean.setErrorMessage(PeopleConst.M032001);
			inputFrameErrorBean.setActionId("PeopleInsert.reDisplay");
			inputFrameErrorBean.setButtonType(InputFrameErrorBean.BUTTON_TYPE_RETURN);

			//エラー情報をセッションに追加する
			session.setAttribute(MailTemplateConstant.KEY_ERROR_INFO, inputFrameErrorBean);

			//エラー画面へ遷移するための状態を設定し、メソッドを終了する。
			xmsResponse.setBusinessStatus("error");
			return;
		}

		if (CommonUtil.checkMailAuthority(xmsRequest) == true) {
			//ログインユーザは、メール使用可能である
			//メールテンプレート付きの画面を表示するステータスをセットする
			xmsResponse.setBusinessStatus("mailAuthorityOK");

			//ユーザ登録画面JSPのために、メールテンプレート使用可能を表す値をセットする
			peopleFormInfoBean.setIsUsableMailTemplate(true);

			//メール種別情報をセッションに登録
			session.setAttribute("XMM_MT_MailType", MailConst.TYPE_REGIST);

		} else {
			//ログインユーザは、メール使用不可能である。
			//メールテンプレート無しの画面を表示するステータスをセット
			xmsResponse.setBusinessStatus("mailAuthorityNG");

			//ユーザ登録画面JSPのために、メールテンプレート使用不可能を表す値をセット
			peopleFormInfoBean.setIsUsableMailTemplate(false);

		}

		//メールテンプレート使用可能／不能情報及び
		//セッションに登録フォーム退避情報を追加
		session.setAttribute(PeopleConst.PeopleFormInfoSessionKey, peopleFormInfoBean);

		//セッションキー保持クラスのセッションからの取得試行及び、セッションへの登録用
		SKeyKeep skeyKeep = null;

		skeyKeep = (SKeyKeep) session.getAttribute(PeopleConst.SKeyKeepSessionKey);
		if (skeyKeep == null) {
			//まだ、セッションキー保持クラスのインスタンスがセッションに存在していない
			//新たに生成する
			skeyKeep = new SKeyKeep();
		}
		skeyKeep.addSKey(PeopleConst.PeopleFormInfoSessionKey); //フォーム退避情報のキーを追加
		//セッションキー保持クラスのインスタンスをセッションに登録
		session.setAttribute(PeopleConst.SKeyKeepSessionKey, skeyKeep);

	}
}
